# DataSets

[![Version](https://juliahub.com/docs/DataSets/version.svg)](https://juliahub.com/ui/Packages/DataSets/4adr3)
[![docs latest](https://img.shields.io/badge/docs-latest-blue.svg)](https://juliahub.com/docs/DataSets)

DataSets helps make data wrangling code more reusable.

* We want to make it easy to *relocate* an algorithm between different **data
  storage environments** without code changes. For example from your laptop to
  the cloud, to another user's machine, or to an HPC system.
* We want to reduce coupling between data and code, by storing **rich type
  information** in metadata. Metadata bridges the gap between the ad hoc
  implicit type system of data outside your program and the Julia data
  structures within your program.

Watch [**DataSets.jl talk**](https://www.youtube.com/watch?v=PJkf0CO5APs) from
JuliaCon 2021, or read [**the latest documentation**](https://juliahub.com/docs/DataSets)
more information.

### Development

[![docs-dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliacomputing.github.io/DataSets.jl/dev)
[![Build Status](https://github.com/JuliaComputing/DataSets.jl/workflows/CI/badge.svg)](https://github.com/JuliaComputing/DataSets.jl/actions)
